Screen _NewImage(1920, 1080, 32)
_FullScreen

Type menutype
    clicked As _Byte
    length As _Unsigned _Byte
    hoverColor As _Unsigned Long
    defaultColor As _Unsigned Long
    hoverBgcolor As _Unsigned Long
    defaultBgColor As _Unsigned Long
    boxColor As _Unsigned Long
    dividerColor As _Unsigned Long
    borderColor As _Unsigned Long
    highLightColor As _Unsigned Long
    notActiveColor As _Unsigned Long
End Type

Type menuItemsType
    Id As Integer
    x As Integer
    length As Integer
    active As Integer
End Type

Type submenutype
    y As Integer
    clicked As Integer
    shortKey As String * 1
    KeyName As String * 1
    shortKeyPosition As Integer
    notActive As Integer
End Type

Dim Shared MenuBar As menutype, menuItems(20) As menuItemsType, menuItemsValue(20) As String
Dim Shared Menu(20, 50) As String, SubMenu(10, 50) As submenutype
Dim Shared fontHandle As Long

fontHandle = _LoadFont("Carthage-Sans-Bold.ttf", 14)
_Font fontHandle

MenuBar.length = 0 'numbers of menu items
MenuBar.defaultBgColor = _RGBA(255, 255, 255, 255)
MenuBar.defaultColor = _RGB(0, 0, 0)
MenuBar.hoverBgcolor = _RGB(211, 139, 33)
MenuBar.hoverColor = _RGB(255, 255, 255)
MenuBar.dividerColor = _RGB(0, 0, 0)
MenuBar.boxColor = _RGB(0, 0, 0)
MenuBar.highLightColor = _RGB(255, 255, 0)
MenuBar.notActiveColor = _RGB(150, 150, 150)

Menu(0, 0) = "About This Computer"
Menu(0, 1) = "{{divider}}"
Menu(0, 2) = "Xterm"
Menu(0, 3) = "Browser"
Menu(0, 4) = "Calculator"
Menu(0, 5) = "File Manager"
Menu(0, 6) = "Text Editior"
Menu(0, 7) = "{{divider}}"
Menu(0, 8) = "Exit"
Menu(0, 9) = "Restart"
Menu(0, 10) = "Shutdown"
menuItems(0).length = 10 'number of sub menus
menuItemsValue(0) = "System"

Dim Wallpaper As _Unsigned Long
Wallpaper = initializeBackground("Gold Weave.bmp", "TILED")
_PutImage (0, 0), Wallpaper

'initialize out menu bar
GuiMenuBarInit

'this our main loop
' whenever mouse will reach out menu we will call GuiMenuBar SUB
Do
    Do
        If MenuBar.clicked Then MenuBar.clicked = 0: Exit Do
        If _MouseInput Then
            xpos = _MouseX: ypos = _MouseY: mouse = -1
            Exit Do
        End If
    Loop
    If mouse Then
        If ypos < 20 Then GuiMenuBar
    End If

    If SubMenu(0, 2).clicked Then
        Shell _DontWait "xterm &"
        SubMenu(0, 2).clicked = 0
    End If

    If SubMenu(0, 3).clicked Then
        Shell _DontWait "exo-open --launch WebBrowser &"
        SubMenu(0, 3).clicked = 0
    End If

    If SubMenu(0, 4).clicked Then
        Shell _DontWait "mate-calc &"
        SubMenu(0, 4).clicked = 0
    End If

    If SubMenu(0, 5).clicked Then
        Shell _DontWait "exo-open --launch FileManager &"
        SubMenu(0, 5).clicked = 0
    End If

    If SubMenu(0, 6).clicked Then
        Shell _DontWait "mousepad &"
        SubMenu(0, 6).clicked = 0
    End If


    If SubMenu(0, 8).clicked Then
        System
    End If

    If SubMenu(0, 9).clicked Then
        Shell _DontWait "shutdown -r now"
    End If

    If SubMenu(0, 10).clicked Then
        Shell _DontWait "shutdown -h now"
    End If

    _Display
Loop

Sub GuiMenuBar ()
    tmp2& = _CopyImage(0)

    drawMenuBar

    For i = 0 To MenuBar.length
        Color MenuBar.defaultColor, MenuBar.defaultBgColor
        _PrintString (menuItems(i).x, 3), menuItemsValue(i)
    Next

    For i = 0 To MenuBar.length
        If menuItems(i).active Then
            Line (menuItems(i).x - 6, 0)-(Len(menuItemsValue(i)) * 8 + 6 + menuItems(i).x, 19), MenuBar.hoverBgcolor, BF
            Color MenuBar.hoverColor, MenuBar.hoverBgcolor
            _PrintString (menuItems(i).x, 3), menuItemsValue(i)
            ml = 0
            If menuItems(i).x - 6 < 0 Then bx = menuItems(i).x Else bx = menuItems(i).x - 6
            by = 20
            id = menuItems(i).Id
            Color MenuBar.defaultColor, MenuBar.defaultBgColor
            For n = 0 To menuItems(i).length
                g = Len(Menu(id, n))
                If g > c Then bx2 = (g * 9 + 20) + menuItems(i).x: c = g
            Next
            For n = 0 To menuItems(i).length
                If Menu(id, n) <> "{{divider}}" Then ml = ml + 1
            Next
            by2 = ml * 28 + 20 + 19
            tmp& = _CopyImage(0)
            Line (bx + 2, by + 2)-(bx2 + 2, by2 + 2), MenuBar.boxColor, BF
            Line (bx, by)-(bx2, by2), MenuBar.defaultBgColor, BF
            Line (bx, by)-(bx2 + 1, by2 + 1), MenuBar.boxColor, B
            ay = 34
            For n = 0 To menuItems(i).length
                SubMenu(id, n).y = ay
                If Menu(id, n) = "{{divider}}" Then
                    Line (bx, ay + 1)-(bx2, ay + 1), MenuBar.dividerColor: ay = ay - 15
                Else
                    _PrintString (bx + 6, SubMenu(id, n).y), Menu(id, n)
                End If
                ay = ay + 24
            Next
        End If
    Next
    _Display
    Do
        Do
            If _MouseInput Then
                x = _MouseX: y = _MouseY
                If _MouseButton(1) Then mclick = -1 Else mclick = 0
                mouse = -1
                Exit Do
            End If
        Loop
        If mouse Then
            If y > 19 Then Screen tmp2&: Exit Sub
            For i = 0 To MenuBar.length
                If x > menuItems(i).x - 6 And y > 0 And y < 19 And x < Len(menuItemsValue(i)) * 8 + 6 + menuItems(i).x Or menuItems(i).active Then
                    If mclick Or menuItems(i).active Then
                        If menuItems(i).active Then
                            menuItems(i).active = 0
                            Line (menuItems(i).x - 6, 0)-(Len(menuItemsValue(i)) * 8 + 6 + menuItems(i).x, 19), MenuBar.hoverBgcolor, BF
                            Color MenuBar.hoverColor, MenuBar.hoverBgcolor
                            _PrintString (menuItems(i).x, 3), menuItemsValue(i)
                        End If
                        ml = 0: c = 0
                        If menuItems(i).x - 6 < 0 Then bx = menuItems(i).x Else bx = menuItems(i).x - 6
                        by = 20
                        id = menuItems(i).Id
                        For n = 0 To menuItems(i).length
                            g = Len(Menu(id, n))
                            If g > c Then bx2 = (g * 9) + menuItems(i).x: c = g
                        Next
                        For n = 0 To menuItems(i).length
                            If Menu(id, n) <> "{{divider}}" Then ml = ml + 1
                        Next
                        by2 = ml * 28 + 24
                        tmp& = _CopyImage(0)
                        Line (bx, by)-(bx2, by2), MenuBar.defaultBgColor, BF
                        Line (bx - 1, by)-(bx2 + 1, by2 + 1), MenuBar.boxColor, B
                        ay = 34
                        For n = 0 To menuItems(i).length
                            SubMenu(id, n).y = ay
                            If Menu(id, n) = "{{divider}}" Then
                                Line (bx, ay + 1)-(bx2, ay + 1), MenuBar.dividerColor: ay = ay - 15
                            Else _PrintString (bx + 10, SubMenu(id, n).y), Menu(id, n)
                            End If
                            ay = ay + 24
                        Next
                        Do

                            Do
                                k$ = InKey$
                                If k$ <> "" Then keyPressed = -1: Exit Do
                                If _MouseInput Then
                                    x = _MouseX: y = _MouseY
                                    If x > bx2 And _MouseButton(1) And y > by Or y > by2 And _MouseButton(1) Or x < bx And _MouseButton(1) And y > by Then
                                        Screen tmp2&: Exit Sub
                                    End If
                                    If y < by And x < Len(menuItemsValue(MenuBar.length)) * 8 + 6 + menuItems(MenuBar.length).x And Point(x, 1) <> MenuBar.hoverBgcolor And _MouseButton(1) Then
                                        For n = 0 To MenuBar.length
                                            If x > menuItems(n).x - 6 And x < Len(menuItemsValue(n)) * 8 + 6 + menuItems(n).x Then
                                                menuItems(n).active = -1: Screen tmp2&: Exit Sub
                                            End If
                                        Next
                                    End If
                                    mouse = -1
                                    If _MouseButton(1) Then mclick = -1 Else mclick = 0
                                    Exit Do
                                End If
                            Loop
                            If mouse Then
                                For n = 0 To menuItems(i).length
                                    If Menu(id, n) <> "{{divider}}" Then
                                        If x > bx + 2 And x < bx2 - 2 And y > SubMenu(id, n).y - 4 And y < SubMenu(id, n).y + 20 And Not SubMenu(id, n).notActive Then
                                            If mclick Then
                                                SubMenu(id, n).clicked = -1: Screen tmp2&
                                                Exit Sub
                                            End If
                                            Line (bx, SubMenu(id, n).y - 4)-(bx2, SubMenu(id, n).y + 20), MenuBar.hoverBgcolor, BF
                                            Color MenuBar.hoverColor, MenuBar.hoverBgcolor
                                            _PrintString (bx + 6, SubMenu(id, n).y), Menu(id, n)
                                            Color MenuBar.highLightColor, MenuBar.hoverBgcolor
                                        Else
                                            Line (bx, SubMenu(id, n).y - 4)-(bx2, SubMenu(id, n).y + 20), MenuBar.defaultBgColor, BF
                                            Color MenuBar.defaultColor, MenuBar.defaultBgColor
                                            _PrintString (bx + 6, SubMenu(id, n).y), Menu(id, n)
                                            Color MenuBar.highLightColor, MenuBar.defaultBgColor
                                        End If

                                        If x > bx + 2 And x < bx2 - 2 And y > SubMenu(id, n).y - 4 And y < SubMenu(id, n).y + 20 And SubMenu(id, n).notActive Then
                                            Line (bx, SubMenu(id, n).y - 4)-(bx2, SubMenu(id, n).y + 20), MenuBar.notActiveColor, BF
                                            Color MenuBar.hoverColor, MenuBar.notActiveColor
                                            _PrintString (bx + 6, SubMenu(id, n).y), Menu(id, n)
                                            Color MenuBar.highLightColor, MenuBar.notActiveColor
                                        End If
                                    End If
                                Next n
                            End If
                            _Display
                        Loop
                    End If
                    Line (menuItems(i).x - 6, 0)-(Len(menuItemsValue(i)) * 8 + 6 + menuItems(i).x, 19), MenuBar.hoverBgcolor, BF
                    Color MenuBar.hoverColor, MenuBar.hoverBgcolor
                    _PrintString (menuItems(i).x, 3), menuItemsValue(i)
                Else
                    Line (menuItems(i).x - 6, 0)-(Len(menuItemsValue(i)) * 8 + 6 + menuItems(i).x, 19), MenuBar.defaultBgColor, BF
                    Color MenuBar.defaultColor, MenuBar.defaultBgColor
                    _PrintString (menuItems(i).x, 3), menuItemsValue(i)
                End If
            Next
        End If
        _Display
    Loop
End Sub

Sub GuiMenuBarInit ()
    drawMenuBar
    a = 20
    For i = 0 To MenuBar.length
        menuItems(i).Id = i
        menuItems(i).x = a
        a = a + (Len(menuItemsValue(i)) * 8 + 12)
    Next
    For i = 0 To MenuBar.length
        Color MenuBar.defaultColor, MenuBar.defaultBgColor
        _PrintString (menuItems(i).x, 3), menuItemsValue(i)
    Next
End Sub

Sub drawMenuBar
    Line (0, 0)-(_Width(0), 20), MenuBar.defaultBgColor, BF
    Line (0, 20)-(_Width(0), 20), _RGBA(0, 0, 0, 255)
End Sub

Function initializeBackground~& (Filename As String, backgroundOptions As String)
    backgroundOptions = UCase$(backgroundOptions)
    If _FileExists(Filename) Then
        Dim temp As _Unsigned Long
        Dim backgroundHandle As Long
        backgroundHandle = _LoadImage(Filename, 32)
        Select Case backgroundOptions
            Case "RAW"
                _PutImage (0, 0)-(_Width, _Height), backgroundHandle, temp, (0, 0)-(_Width, _Height)
            Case "SCALED"
                _PutImage , backgroundHandle, temp
            Case "TILED"
                Dim tileWidth As _Unsigned Integer: tileWidth = _Width(backgroundHandle)
                Dim tileHeight As _Unsigned Integer: tileHeight = _Height(backgroundHandle)
                Dim numberWide As Single: numberWide = _Width \ tileWidth
                Dim numberHigh As Single: numberHigh = _Height \ tileHeight
                Dim currentDesktopHigh As _Unsigned Integer
                Dim currentDesktopWide As _Unsigned Integer
                For currentDesktopHigh = 0 To numberHigh
                    For currentDesktopWide = 0 To numberWide
                        _PutImage (tileWidth * currentDesktopWide, tileHeight * currentDesktopHigh), backgroundHandle, temp
                    Next currentDesktopWide
                Next currentDesktopHigh
        End Select
        initializeBackground = temp
    End If
End Function

